local function cancelcharge(p)
	if (p.pflags & PF_SLIDING)
	or P_PlayerInPain(p)
	or p.mo.eflags & MFE_SPRUNG
	or p.powers[pw_carry]
	or p.spectator
	or p.playerstate != PST_LIVE
	or not p.mo.health
	or p.powers[pw_super] == 1
	or p.iseggrobo
	or p.powers[pw_nocontrol] > 0
		return true
	else
		return false
	end
end

local function resetfire(p)
	if p.mo and p.mo.valid
		p.flameangle = 0
		p.flamewaveleft = false
		p.flamecharging = false
		p.usedflamecharge = 0
		p.fcsound = 0
		p.fcstartup = 0
		p.fcbounce = 0
		p.mo.flamechargeshield = false
		p.normalspeed = 35*FRACUNIT
	end
end

local function SpawnFireTrail(p)
	if p.mo and p.mo.valid and p.mo.skin == "fire"
		local trail = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_FIRTRAIL)
		if p.mo.eflags & MFE_VERTICALFLIP
			trail.flags2 = $ | MF2_OBJECTFLIP
		end
		trail.fuse = TICRATE*3
		trail.scale = p.mo.scale
	end
end


local function SpawnFireResidue(fire)
	for i = 1, 8
		local residue = P_SpawnMobj(fire.x, fire.y, fire.z+((2*FRACUNIT)*P_MobjFlip(fire)), MT_FIRTRAIL)
		if fire.eflags & MFE_VERTICALFLIP
			residue.flags2 = $ | MF2_OBJECTFLIP
		end
		residue.fuse = TICRATE*3
		residue.scale = fire.scale
		P_InstaThrust(residue, (i*ANGLE_45) + P_RandomRange(1, 45), 3*fire.scale)
		P_SetObjectMomZ(residue, 5*fire.scale*P_MobjFlip(fire), false)
	end
end

local function bouncecheck(fire)
	if fire and fire.valid
		if fire.player.powers[pw_super] 
		or fire.player.powers[pw_sneakers]
		or fire.player.mysticsuper
			if fire.player.powers[pw_super] and not (fire.player.hyper and fire.player.hyper.capable)
			or fire.player.powers[pw_sneakers]
				return 10
			elseif fire.player.mysticsuper or fire.player.powers[pw_super] and fire.player.hyper and fire.player.hyper.capable
				return 9001
			end
		else
			return 5
		end
	end
end

local FireBreakables = {
    [MT_SPIKE] = 1,
    [MT_WALLSPIKE] = 2,
    [MT_WALLSPIKEBASE] = 3,
    [MT_EGGSHIELD] = 4
}

local function FireMobjBreaker(fire, mo)
	if fire and fire.valid
	and fire.player and fire.player.valid
	and fire.skin == "fire"
	and fire.player.flamecharging
		if mo and mo.valid
			P_KillMobj(mo)
			mo.colorized = true
			if fire.color != skins[fire.skin].prefcolor
				mo.color = ColorOpposite(fire.color)
			else
				mo.color = SKINCOLOR_KETCHUP
			end
		end
	end
end

local function EndFireCharge(fire)
	fire.player.flamecharging = false
	P_DoPlayerPain(fire.player)
	S_StartSound(fire,sfx_s3kaa)
end


addHook("PlayerSpawn", resetfire)
--addHook("PostThinkFrame", function(p)
	--for p in players.iterate
		--if p.mo and p.mo.valid and p.mo.skin == "fire"
			--p.mo.frame = $ | TR_TRANS10
		--end
	--end
--end)
addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid and p.mo.skin == "fire"  
--its good practice to keep validity checks in one line.
		if p.powers[pw_carry]
			p.usedflamecharge = 0
			if p.powers[pw_carry] & CR_ROLLOUT
			and p.mo.state == S_PLAY_SPRING
				p.mo.state = S_PLAY_STND
			end
		end
		--if p.powers[pw_super] and p.hyper and p.hyper.capable
		--	p.mo.colorized = true
		--else
		--	p.mo.colorized = false
		--end
		if p.flameangle > 11
		and p.flamewaveleft == false
			p.flamewaveleft = true
		end
		if p.flameangle < -11
		and p.flamewaveleft == true
			p.flamewaveleft = false
		end
		if (P_GetMobjGravity(p.mo) < 0) 
			if (p.mo.momz < 0) 
				p.mo.momz = $ - P_GetMobjGravity(p.mo) / 2
			end
		end
		if (P_GetMobjGravity(p.mo) > 0) 
			if (p.mo.momz > 0) 
				p.mo.momz = $ - P_GetMobjGravity(p.mo) / 2
			end
		end
        if(p.rings >= 20)
            p.charability2 = CA2_NONE
			if(p.mo.state == S_PLAY_CHFL) 
				p.drawangle = p.mo.angle
				p.normalspeed = 10*FRACUNIT
			else
				p.normalspeed = 35*FRACUNIT
			end
		else
			p.charability2 = CA2_GUNSLINGER
			p.normalspeed = 35*FRACUNIT
		end
		if p.flamecharging
			if cancelcharge(p)
				p.flamecharging = false
			end
			p.mo.state = S_PLAY_FCROLL
			p.drawangle = p.mo.angle
			p.mo.flags = $1|MF_BOUNCE
			p.pflags = $1|PF_JUMPSTASIS
			p.mo.momz = 0
			if p.fcstartup < 20 
				p.fcstartup = $+1
				p.mo.momy = 0
				p.mo.momx = 0
			end
			if p.fcstartup == 19
				if p.mysticsuper or p.powers[pw_super] and p.hyper and p.hyper.capable
					SpawnFireResidue(p.mo)
				end
				p.chargeangle = p.mo.angle
			end
			if p.fcstartup > 19
				if P_IsObjectOnGround(p.mo)
					SpawnFireTrail(p)
				end
				p.drawangle = p.chargeangle
				p.charability = CA_GLIDEANDCLIMB
				if not p.mo.flamechargeshield
					local charge = P_SpawnMobj(
						p.mo.x, 
						p.mo.y, p.mo.z,
						MT_FLMCHARGSHIELD
					)
					charge.target = p.mo
					p.mo.flamechargeshield = true
				end
				if p.fcsound == 0
					p.fcsound = 1
					S_StartSound(p.mo,sfx_zoom)
--dont use number values to choose the sound, SRB2 may add some more that may ruin the sound choices.
				end
				if p.powers[pw_sneakers] 
				or p.powers[pw_super] 
				or p.mysticsuper
					if p.powers[pw_sneakers] or p.powers[pw_super]
						P_InstaThrust(
							p.mo,
							p.chargeangle,
							FixedMul(FRACUNIT*60, p.mo.scale)
						)
					elseif p.mysticsuper or p.powers[pw_super] and p.hyper and p.hyper.capable
						SpawnFireTrail(p)
						P_InstaThrust(
							p.mo,
							p.chargeangle,
							FixedMul(FRACUNIT*80, p.mo.scale)
						)
					end
				else
					P_InstaThrust(
						p.mo,
						p.chargeangle,
						FixedMul(FRACUNIT*40, p.mo.scale)
					)
				end
			end	
		else
			p.mo.flags = $1 & ~MF_BOUNCE
			p.fcstartup = 0
			p.mo.flamechargeshield = false
			p.charability = CA_NONE
		end
		if p.mo.eflags & MFE_JUSTHITFLOOR or(p.mysticsuper or p.powers[pw_super] and p.hyper and p.hyper.capable)
			p.usedflamecharge = 0
		end
    end
end)

addHook("AbilitySpecial", function(p)
	if p.mo and p.mo.valid and p.mo.skin == "fire" 
		if not p.flamecharging 
			if (p.usedflamecharge == 0) 
				p.flamecharging = true
				S_StartSound(p.mo,sfx_spin)
				p.usedflamecharge = 1
				p.fcsound = 0
				p.fcstartup = 0
				p.fcbounce = 0
			end
		end
	end
end)

addHook("PlayerCanDamage", function(p)
	if p.mo and p.mo.valid and p.mo.skin == "fire"
		if p.flamecharging
			return true
		end
	end
end)

addHook("SpinSpecial", function(p)
	if p.mo and p.mo.valid and p.mo.skin == "fire"  --and also use them in every hook, something *could* happen where you may perform an action with an invalid mobj, and srb2 would scream.
		if p.flamecharging
			if not (p.pflags & PF_USEDOWN) 
				p.flamecharging = false
				if p.fcstartup > 19
					p.pflags = $ & ~PF_STARTJUMP
					P_SetObjectMomZ(p.mo, 5*FRACUNIT, true)
				end
			end
		end
		if(p.rings >= 20) 
			if P_IsObjectOnGround(p.mo) 
			and not (cancelcharge(p) or p.exiting)
				if p.flamewaveleft == true
					p.flameangle = $-1
				else
					p.flameangle = $+1
				end
				if leveltime%3==0
					local fthrower = P_SPMAngle(
						p.mo,
						MT_FIRFLARBAR,
						p.mo.angle+(p.flameangle)*ANG1,
						1
					)
					if (fthrower and fthrower.valid)
						fthrower.fuse = 15
					end
				end
				p.mo.state = S_PLAY_CHFL
			end
		end
	end
end)

addHook("MobjThinker", function(c)
	if c and c.valid
		if c.target and c.target.valid
		and c.target.player and c.target.player.valid
			local ctarget = c.target		
			c.colorized = true
			if ctarget.eflags & MFE_VERTICALFLIP
				c.flags2 = $ | MF2_OBJECTFLIP
			end
			if ctarget.color != skins[ctarget.skin].prefcolor
				c.color = ColorOpposite(ctarget.color)
			else
				c.color = SKINCOLOR_KETCHUP
			end
			P_TeleportMove(c, ctarget.x, ctarget.y, ctarget.z)
			c.angle = ctarget.player.chargeangle
			c.scale = FixedMul(ctarget.scale, ctarget.player.shieldscale)
			if leveltime % 2 == 0
				c.frame = FF_FULLBRIGHT|TR_TRANS50|S
			else
				c.frame = FF_FULLBRIGHT|TR_TRANS60|S
			end
			if ctarget.player.powers[pw_sneakers] 
			or ctarget.player.powers[pw_super] 
			or ctarget.player.mysticsuper
				local cg = P_SpawnGhostMobj(c)
				cg.color = c.color
				cg.colorized = true
				cg.angle = c.angle
				cg.scale = c.scale
				cg.fuse = 4
				cg.frame = FF_FULLBRIGHT|TR_TRANS90|S
				if c.flags2 & MF2_OBJECTFLIP
					cg.flags2 = $ | MF2_OBJECTFLIP
				end
			end
			if not ctarget.player.flamecharging
				P_RemoveMobj(c)
			end
		end
	end
end, MT_FLMCHARGSHIELD)

addHook("MobjDamage", function(fire)
	if fire and fire.valid
	and fire.player and fire.player.valid
	and fire.skin == "fire"
		fire.normalspeed = 35*FRACUNIT
		if fire.player.flamecharging
			fire.player.flamecharging = false
			P_DoPlayerPain(fire.player)	
		end
	end
end, MT_PLAYER)

addHook("MobjDeath", function(fire)
	if fire and fire.valid
	and fire.player and fire.player.valid
	and fire.skin == "fire"
		if fire.player.flamecharging
			fire.player.flamecharging = false
		end
	end
end, MT_PLAYER)

addHook("MobjMoveCollide", function(fire, mo)
	if fire and fire.valid and fire.player and fire.player.valid
	and fire.skin == "fire" and fire.player.flamecharging
		if mo and mo.valid
			if mo.z == fire.z
			or (mo.z < fire.z and (mo.z + mo.height) > fire.z)
			or (mo.z + mo.height) == fire.z
			or (fire.z < mo.z and (fire.z + fire.height) > mo.z)
				if (mo.flags & (MF_BOSS|MF_MONITOR|MF_ENEMY))	
					P_DamageMobj(mo, fire, fire, 1)
					if mo.flags & MF_BOSS
						EndFireCharge(fire)
					elseif mo.flags & MF_MONITOR|MF_ENEMY
						if mo.health == 0
							SpawnFireResidue(fire)
							return false
						else
							return true
						end								
					end
				elseif mo.flags & MF_SPRING
					fire.player.flamecharging = false
				elseif FireBreakables[mo.type]
					FireMobjBreaker(fire, mo)
					if FireBreakables[mo.type] == 4
						S_StartSound(mo,sfx_wbreak)
						return true
					end
				elseif mo.flags & MF_PUSHABLE
					P_InstaThrust(mo, fire.player.chargeangle, fire.player.speed/4)
					return true
				end
			end
		end
	end
end, MT_PLAYER)


addHook("MobjMoveBlocked", function(fire)
	if fire and fire.valid --mobj check
	and fire.player and fire.player.valid and fire.skin == "fire"  --player check
		if fire.player.flamecharging 
			if (fire.player.fcbounce < bouncecheck(fire)) 
				fire.player.fcbounce = $+1
				P_BounceMove(fire)
				fire.angle = R_PointToAngle2(0, 0, fire.momx, fire.momy)
				fire.player.chargeangle = fire.angle
				S_StartSound(fire,sfx_s3kaa)
			end
			if (fire.player.fcbounce > (bouncecheck(fire) - 1)) 
				EndFireCharge(fire)
			end
		end
	end
end, MT_PLAYER)


addHook("ShouldDamage", function(fire, mo, s, a, dmgtype)
	if fire and fire.valid
	and fire.player and fire.player.valid 
	and fire.skin == "fire"
	and fire.player.flamecharging 
		if dmgtype & DMG_FIRE
		or (mo and mo.valid and mo.flags & MF_FIRE)
			return false
		end
	end
end, MT_PLAYER)

addHook("MobjFuse", function(residue)
	if residue and residue.valid
		residue.state = S_SMOKE1
		if residue.state == S_NULL
			P_RemoveMobj(residue)
		end
		return true
	end
end, MT_FIRTRAIL)
		
